function cplot3d(x,y,z,c,theta,alpha,leg,flag,ebox,cext)
// plot of colored curves in 3d
// from cplot
[lhs,rhs]=argn(0)

if rhs==0 then
  demo=['  x=(0:0.1:2*%pi); y=sin(x); z=cos(2*x); cplot3d(x,y,z)']
  write(%io(2),demo)
  execstr(demo);
  return
end

if ~exists('c','local') then c=z; end
if ~exists('theta','local') then theta=35; end
if ~exists('alpha','local') then alpha=45; end
if ~exists('flag','local') then flag=[6 4]; end
if ~exists('leg','local') then leg='x@y@z'; end
if ~exists('ebox','local') then ...
   xmx=max(x);xmn=min(x);ymx=max(y);ymn=min(y);zmx=max(z);zmn=min(z);
   ebox=[xmn,xmx,ymn,ymx,zmn,zmx]; 
end
if ~exists('cext','local') then cext=[min(c),max(c)];  end

nc=xget("lastpattern");

//plot the curves with current colormap
  X=[matrix(x(:,1:$-1),1,-1);matrix(x(:,2:$),1,-1)]
  Y=[matrix(y(:,1:$-1),1,-1);matrix(y(:,2:$),1,-1)]
  Z=[matrix(z(:,1:$-1),1,-1);matrix(z(:,2:$),1,-1)]
  C=[matrix(c(:,1:$-1),1,-1)]
  if cext(2)<>cext(1) then
     C=(nc-1)*(C-cext(1))/(cext(2)-cext(1))+1;
  else
     C=ones(C);
  end
  C(find(isnan(C)))=nc+1;
  param3d1(X,Y,list(Z,C),theta,alpha,leg,flag,ebox)

return

