function cpoints(x,y,a,d,strf,leg,rect,nax)
//plots colored dots of size d at the coordinates x,y
// x,y,a row or column vectors, all of the same length
// if d<0 squares are plot instead of dots (some twice as fast)
// minimal syntax:  cpoints(x,y,a,[d])
//  the other argumens are just passed to plot2d
// if a= constant * ones(x) then black dots are plotted (color nc+1)

[rhs,lhs]=argn(0);
if lhs==0 then
  demo=['x=(0:0.1:2*%pi)''';'y=sin(x)';'cpoints(x,y,y,4)';..
                  'y=sin(x+.2);'; 'cpoints(x,y,-y,-3)' ]
  write(%io(2),demo)
  execstr(demo)
  return
end

if lhs==3 then d=1; end
if lhs<=4 then strf='011'; end
if lhs<=5 then leg=' '; end
if lhs<=6 then
   if part(strf,2)=='0' then 
     [frect,frect1]=xgetech(); xmn=frect(1); xmx=frect1(1)+frect1(3);
       ymn=frect(2); ymx=frect1(2)+frect1(4);
   else 
     xmx=max(x); xmn=min(x); ymx=max(y); ymn=min(y);
   end
end
if lhs<=7 then nax=[1,5,1,5];  end
if lhs>=7 then 
   xmx=rect(3); xmn=rect(1); ymx=rect(4); ymn=rect(2)
end

dx=d*(xmx-xmn)/200; dy=d*(ymx-ymn)/200; lx=length(x);
xx=matrix(x,lx,1)-dx/2; yy=matrix(y,lx,1)+dy/2;

amin=min(a); amax=max(a);
nc=xget("lastpattern");
if amin<amax then
  cz=matrix(1+(nc-1)*(a-amin)/(amax-amin),length(x),1);
else
  cz=(nc+1)*ones(length(x),1)
end

plot2d([min(x),max(x)],[min(y),max(y)],0,strf,leg,[xmn,ymn,xmx,ymx],nax)
// this plot two of the points as tiny dots, better than anything
//  more intrusive; does the job of setting the plot window
// (leg is not of much sense, it comes out only the legend of a 
//  single tiny dot, but that's here for compatibility

xset('clipgrf')

if d<0 then
  xrects([xx'+dx*ones(1,lx);yy'-dy*ones(1,lx);...
     -dx*ones(1,lx); -dy*ones(1,lx)],cz);
end

if d>0 then xfarcs([xx';yy';dx*ones(1,lx);dy*ones(1,lx);zeros(1,lx);...
  64*360*ones(1,lx)],cz); end


xset('clipoff')

return
