function []=errbar(x,y,em,ep,sty)
// Rajoute des barres d'erreur sur un graphique 2D
// x et y decrivent les courbes (voir plot2d)
// em et ep sont deux matrices la barre d'erreur au point
// <x(i,j),y(i,j)> va de <x(i,j),y(i,j)-em(i,j)> a <x(i,j),y(i,j)+em(i,j)>
// x,y,em et ep sont donc des matrices (p,q), q courbes contenant chacunes
// p points.
// Exemple : taper errbar()
//      x=0:0.1:2*%pi;
//   y=<sin(x);cos(x)>';x=<x;x>';plot2d(x,y);
//   errbar(x,y,0.05*ones(x),0.03*ones(x));
//!
// Copyright INRIA
//   modifie par Enrico Segre
[lhs,rhs]=argn(0)
if rhs<=0,write(%io(2),'  x=0:0.1:2*%pi;');
   write(%io(2),'  y=[sin(x);cos(x)]'';x=[x;x]'''); 
   write(%io(2),'  plot2d(x,y);');
   write(%io(2),'  errbar(x,y,0.05*ones(x),0.03*ones(x),[1,2]);');
   x=0:0.1:2*%pi;
   y=[sin(x);cos(x)]';x=[x;x]';plot2d(x,y);
   errbar(x,y,0.05*ones(x),0.03*ones(x),[1,2]);
   return;end;
xselect();
[n1,n2]=size(x);
if rhs==4,sty=ones(1,n1*n2); end;
if rhs==5 & length(sty)>1, sty=matrix(ones(n1,1)*sty,1,n1*n2);end
y1=matrix(y-em,1,n1*n2);
x1=matrix(x,1,n1*n2);
y2=matrix(y+ep,1,n1*n2);
yy=matrix(y,1,n1*n2);
xset("clipgrf");
[r,r1]=xgetech(); d=(r1(3)-r1(1))/150;
xsegs([x1;x1],[y1;y2],sty);
xsegs([x1-d;x1+d],[y1;y1],sty);
xsegs([x1-d/4;x1+d/4],[matrix(y,1,n1*n2);matrix(y,1,n1*n2)],sty);
xsegs([x1-d;x1+d],[y2;y2],sty);
mm=xget('mark'); xset('mark',mm(1),mm(2)-3);
//plot2d(x1,yy,-4*ones(1,n1*n2),'000')
xset('mark',mm(1),mm(2));
xclip();


