function oplot(str,data,sty,strf,leg,rect,nax)
// data: list of x,y pairs (each member can have adifferent length)
// style: 0 points, >0 lines, <0 linespoints
// other arguments just as in plot2d1
//
// syntaxes: oplot(data)
//           oplot(str,data,[sty,strf,leg,rect,nax])
//

deff('plep(str,a,b,sty,i,strf,lab)',..
['    [rhs,lhs]=argn(0);',..
'    a=matrix(a,length(a),1);',..
'    b=matrix(b,length(b),1);',..
'    if lhs==6 then lab=''data ''+string(i); end',..
'    if lab=='''' then lab=''data ''+string(i); end',..
'    if sty<>0 then ',..
'    plot2d1(str,a,b,[i,modulo(i-1,6)+1],part(strf,1)+''00'',lab);',..
'    end',..
'    if sty<=0 then ',..
'    plot2d1(str,a,b,[-i-1,modulo(i-1,6)+1],part(strf,1)+''00'',lab);',..
'    end;',..
'return'])

deff('[m]=maxl1(l)',..
['    m=max(l(1))',..
'    for i=3:2:length(l); m=max(max(l(i)),m); end    ',..
'return'])

deff('[m]=maxl2(l)',..
['    m=max(l(2))',..
'    for i=4:2:length(l); m=max(max(l(i)),m); end    ',..
'return'])

deff('[m]=minl1(l)',..
['    m=min(l(1))',..
'    for i=3:2:length(l); m=min(min(l(i)),m); end    ',..
'return'])

deff('[m]=minl2(l)',..
['    m=min(l(2))';..
'    for i=4:2:length(l); m=min(min(l(i)),m); end    ';..
'return'])

    [rhs,lhs]=argn(0);   

    if lhs==0 then
        write(%io(2),['x1=1:12; x2=-3:6; y1=x1.^1.5; y2=x2.^2/2-1;';..
                      'oplot(list(x1,y1,x2,y2))'])
        x1=1:12; x2=-3:6; y1=x1.^1.5; y2=x2.^2/2-1;
        oplot(list(x1,y1,x2,y2))
        return
    end
    if lhs==1 then data=str;str='gnn'; end
    datalimit=[minl1(data),minl2(data),maxl1(data),maxl2(data)];
    if lhs<7 then nax=[1,5,1,5]; end
    if lhs<6 then rect=datalimit; end
    if lhs<5 then leg =''; end
    if lhs<4 then strf='151'; end
    if lhs<3 then sty=-1; end


//plot the frame (I could rather have used plotframe)
    plot2d1(str,datalimit([1,3])',datalimit([2,4])',0,'0'+part(strf,[2 3]),' ',rect,nax)
// it might still not work for str='xll' and strf='x3x', but that is a problem
//  with plot2d1

//plot the curves with current colormap

    atleg=strindex(leg,'@'); if atleg==[] then atleg=length(leg)+1; end
    nleg=length(atleg)+1;
    for i=1:length(data)/2;
      if i==1 then lab=part(leg,1:(atleg(1)-1)); end
      if i<nleg & i>1 then 
         lab=part(leg,(atleg(i-1)+1):(atleg(i)-1)); 
      end
      if i==nleg then lab=part(leg,(atleg(i-1)+1):length(leg)); end
      if i>nleg then lab =''; end
      if length(data(2*i-1))==length(data(2*i)) then
        plep(str,data(2*i-1),data(2*i),sty,i,strf,lab)
      else
        disp('data '+string(i)+' couple not of the same size -- skipped')
      end
    end
return

