function [xx,yy,zz,cc]=spherecast(a,amin,amax,l)
//
  [lhs,rhs]=argn(0);
  if rhs==3 then l=1; end
  if rhs==2 then l=amin;amin=min(a);amax=max(a); end
  if rhs==1 then l=1;amin=min(a);amax=max(a); end

  if amin>=amax then amin=min(a);amax=max(a); end
  a(find(a<amin))=amin;a(find(a>amax))=amax;

  if l==1 then
    vn=size(a,2)+1
    n=size(a,1)+1
    nf=length(a)
  end
  if l==2 then
    vn=size(a,2)+1
    n=size(a,1)
    nf=(vn-1)*(n-1)
  end

// facelets of the sphere
    u = linspace(-%pi/2,%pi/2,n);
    v = linspace(0,2*%pi,vn);  
    x= cos(u)'*cos(v);
    y= cos(u)'*sin(v);
    z= sin(u)'*ones(v);

  in=1:(n-1); inp=2:n; in2=1:(vn-1)
  xx=[matrix(x(in,in2+1),1,nf);
       matrix(x(in,in2),1,nf);
       matrix(x(inp,in2),1,nf);
       matrix(x(inp,in2+1),1,nf)]
  yy=[matrix(y(in,in2+1),1,nf);
       matrix(y(in,in2),1,nf);
       matrix(y(inp,in2),1,nf);
       matrix(y(inp,in2+1),1,nf)]
  zz=[matrix(z(in,in2+1),1,nf);
       matrix(z(in,in2),1,nf);
       matrix(z(inp,in2),1,nf);
       matrix(z(inp,in2+1),1,nf)]

// color casting

  if l==1 then
     cc=matrix((a-amin)/(amax-amin),1,length(a))
  end
  if l==2 then
    c=(a-amin)/(amax-amin);
    inp=in+1
    in2p=[2:in2($),1]
    cc=[matrix(c(in,in2p),1,nf);
       matrix(c(in,in2),1,nf);
       matrix(c(inp,in2),1,nf);
       matrix(c(inp,in2p),1,nf)]
  end   

return

// esempio:
a=rebin(linspace(0,10,100),linspace(0,10,60), 1:20,1:20,rand(20,20));
[xx,yy,zz,cc]=spherecast(a,1);
xbasc();plot3d1(xx,yy,list(zz,cc*31+1),50,50,'x@y@z',[-1 2 4])
 

